Package org.springframework.asm

# Class Attribute

java.lang.Object
org.springframework.asm.Attribute

public class Attribute extends Object
A non standard class, field, method or Code attribute, as defined in the Java Virtual Machine Specification (JVMS).

Author:
  Eric Bruneton, Eugene Kuleshov
See Also:
  - JVMS 4.7
  - JVMS 4.7.3

## Field Summary

Fields
Modifier and Type
Field
Description
`final String`
`type`
The type of this attribute, also called its name in the JVMS.

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`Attribute(String type)`
Constructs a new empty attribute.

## Method Summary

Modifier and Type
Method
Description
`protected Label[]`
`getLabels()`
Deprecated.
no longer used by ASM.
`boolean`
`isCodeAttribute()`
Returns true if this type of attribute is a Code attribute.
`boolean`
`isUnknown()`
Returns true if this type of attribute is unknown.
`static Attribute`
`read(Attribute attribute, ClassReader classReader, int offset, int length, char[] charBuffer, int codeAttributeOffset, Label[] labels)`
Reads an attribute with the same `type` as the given attribute.
`protected Attribute`
`read(ClassReader classReader, int offset, int length, char[] charBuffer, int codeAttributeOffset, Label[] labels)`
Reads a `type` attribute.
`static Label`
`readLabel(ClassReader classReader, int bytecodeOffset, Label[] labels)`
Returns the label corresponding to the given bytecode offset by calling `ClassReader.readLabel(int, org.springframework.asm.Label[])`.
`static byte[]`
`write(Attribute attribute, ClassWriter classWriter, byte[] code, int codeLength, int maxStack, int maxLocals)`
Returns the byte array form of the content of the given attribute.
`protected ByteVector`
`write(ClassWriter classWriter, byte[] code, int codeLength, int maxStack, int maxLocals)`
Returns the byte array form of the content of this attribute.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### type

public final String type
The type of this attribute, also called its name in the JVMS.

## Constructor Details

### Attribute

protected Attribute(String type)
Constructs a new empty attribute.

Parameters:
  `type` - the type of the attribute.

## Method Details

### isUnknown

public boolean isUnknown()
Returns true if this type of attribute is unknown. This means that the attribute content can't be parsed to extract constant pool references, labels, etc. Instead, the attribute content is read as an opaque byte array, and written back as is. This can lead to invalid attributes, if the content actually contains constant pool references, labels, or other symbolic references that need to be updated when there are changes to the constant pool, the method bytecode, etc. The default implementation of this method always returns true.

Returns:
  true if this type of attribute is unknown.

### isCodeAttribute

public boolean isCodeAttribute()
Returns true if this type of attribute is a Code attribute.

Returns:
  true if this type of attribute is a Code attribute.

### getLabels

@Deprecated(forRemoval=false) protected Label[] getLabels()
Deprecated.
no longer used by ASM.
Returns the labels corresponding to this attribute.

Returns:
  the labels corresponding to this attribute, or null if this attribute is not a Code attribute that contains labels.

### read

protected Attribute read(ClassReader classReader, int offset, int length, char[] charBuffer, int codeAttributeOffset, Label[] labels)
Reads a `type` attribute. This method must return a new `Attribute` object, of type `type`, corresponding to the 'length' bytes starting at 'offset', in the given ClassReader.

Parameters:
  `classReader` - the class that contains the attribute to be read.
  `offset` - index of the first byte of the attribute's content in `ClassReader`. The 6 attribute header bytes (attribute_name_index and attribute_length) are not taken into account here.
  `length` - the length of the attribute's content (excluding the 6 attribute header bytes).
  `charBuffer` - the buffer to be used to call the ClassReader methods requiring a 'charBuffer' parameter.
  `codeAttributeOffset` - index of the first byte of content of the enclosing Code attribute in `ClassReader`, or -1 if the attribute to be read is not a Code attribute. The 6 attribute header bytes (attribute_name_index and attribute_length) are not taken into account here.
  `labels` - the labels of the method's code, or null if the attribute to be read is not a Code attribute. Labels defined in the attribute must be created and added to this array, if not already present, by calling the `readLabel(org.springframework.asm.ClassReader, int, org.springframework.asm.Label[])` method (do not create `Label` instances directly).
Returns:
  a new `Attribute` object corresponding to the specified bytes.

### read

public static Attribute read(Attribute attribute, ClassReader classReader, int offset, int length, char[] charBuffer, int codeAttributeOffset, Label[] labels)
Reads an attribute with the same `type` as the given attribute. This method returns a new `Attribute` object, corresponding to the 'length' bytes starting at 'offset', in the given ClassReader.

Parameters:
  `attribute` - The attribute prototype that is used for reading.
  `classReader` - the class that contains the attribute to be read.
  `offset` - index of the first byte of the attribute's content in `ClassReader`. The 6 attribute header bytes (attribute_name_index and attribute_length) are not taken into account here.
  `length` - the length of the attribute's content (excluding the 6 attribute header bytes).
  `charBuffer` - the buffer to be used to call the ClassReader methods requiring a 'charBuffer' parameter.
  `codeAttributeOffset` - index of the first byte of content of the enclosing Code attribute in `ClassReader`, or -1 if the attribute to be read is not a Code attribute. The 6 attribute header bytes (attribute_name_index and attribute_length) are not taken into account here.
  `labels` - the labels of the method's code, or null if the attribute to be read is not a Code attribute. Labels defined in the attribute are added to this array, if not already present.
Returns:
  a new `Attribute` object corresponding to the specified bytes.

### readLabel

public static Label readLabel(ClassReader classReader, int bytecodeOffset, Label[] labels)
Returns the label corresponding to the given bytecode offset by calling `ClassReader.readLabel(int, org.springframework.asm.Label[])`. This creates and adds the label to the given array if it is not already present. Note that this created label may be a `Label` subclass instance, if the given ClassReader overrides `ClassReader.readLabel(int, org.springframework.asm.Label[])`. Hence `read(ClassReader, int, int, char[], int, Label[])` must not manually create `Label` instances.

Parameters:
  `classReader` - the class that contains the attribute to be read.
  `bytecodeOffset` - a bytecode offset in a method.
  `labels` - the already created labels, indexed by their offset. If a label already exists for bytecodeOffset this method does not create a new one. Otherwise it stores the new label in this array.
Returns:
  a label for the given bytecode offset.

### write

protected ByteVector write(ClassWriter classWriter, byte[] code, int codeLength, int maxStack, int maxLocals)
Returns the byte array form of the content of this attribute. The 6 header bytes (attribute_name_index and attribute_length) must not be added in the returned ByteVector.

This method is only invoked once to compute the binary form of this attribute. Subsequent changes to the attribute after it was written for the first time will not be considered.

Parameters:
  `classWriter` - the class to which this attribute must be added. This parameter can be used to add the items that corresponds to this attribute to the constant pool of this class.
  `code` - the bytecode of the method corresponding to this Code attribute, or null if this attribute is not a Code attribute. Corresponds to the 'code' field of the Code attribute.
  `codeLength` - the length of the bytecode of the method corresponding to this code attribute, or 0 if this attribute is not a Code attribute. Corresponds to the 'code_length' field of the Code attribute.
  `maxStack` - the maximum stack size of the method corresponding to this Code attribute, or -1 if this attribute is not a Code attribute.
  `maxLocals` - the maximum number of local variables of the method corresponding to this code attribute, or -1 if this attribute is not a Code attribute.
Returns:
  the byte array form of this attribute.

### write

public static byte[] write(Attribute attribute, ClassWriter classWriter, byte[] code, int codeLength, int maxStack, int maxLocals)
Returns the byte array form of the content of the given attribute. The 6 header bytes (attribute_name_index and attribute_length) are not added in the returned byte array.

Parameters:
  `attribute` - The attribute that should be written.
  `classWriter` - the class to which this attribute must be added. This parameter can be used to add the items that corresponds to this attribute to the constant pool of this class.
  `code` - the bytecode of the method corresponding to this Code attribute, or null if this attribute is not a Code attribute. Corresponds to the 'code' field of the Code attribute.
  `codeLength` - the length of the bytecode of the method corresponding to this code attribute, or 0 if this attribute is not a Code attribute. Corresponds to the 'code_length' field of the Code attribute.
  `maxStack` - the maximum stack size of the method corresponding to this Code attribute, or -1 if this attribute is not a Code attribute.
  `maxLocals` - the maximum number of local variables of the method corresponding to this code attribute, or -1 if this attribute is not a Code attribute.
Returns:
  the byte array form of this attribute.